/*
 * ptrace-based user-space probes
 * Copyright (c) International Business Machines Corp., 2006
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 *  Project Website:  http://sourceware.org/systemtap
 *
 */
#ifndef _PTPROBES_IMPL_I386_H
#define _PTPROBES_IMPL_I386_H

/* Number of regs got by PTRACE_GETREGS */
#define FRAME_SIZE 17

typedef unsigned char opcode_t;
#define BREAKPOINT_INSTRUCTION 0xcc

#define IPREG EIP

/* On i386, EIP points past the int3 instruction after the int3 is hit. */
#define IP_TO_ADDR(ip) ((ip)-sizeof(opcode_t))

#endif /* _PTPROBES_IMPL_I386_H */
