#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#define noinline __attribute__((noinline))
#define fastcall __attribute__((regparm(3)))

noinline fastcall static int add(int n1, int n2)
{
	return n1 + n2;
}

main(int argc, char **argv)
{
	int i, n, sum;
	struct timeval start, finish;
	long usec;

	if (argc != 2 || (n = atoi(argv[1])) <= 0) {
		fprintf(stderr, "Usage: %s niter\n", argv[0]);
		exit(1);
	}

	// Give parent shell script a chance to start up probing.
	sleep(2);

	sum = 0;
	(void) gettimeofday(&start, NULL);
	for (i = 1; i <= n; i++) {
		sum = add(sum, i);
	}
	(void) gettimeofday(&finish, NULL);
	usec = 1000*1000*(finish.tv_sec - start.tv_sec)
		+ (finish.tv_usec - start.tv_usec);
	printf("%d interations in %.6f sec\n", n, ((double)usec) / (1000*1000));
	printf("%.6f usec per iteration\n", ((double)usec) / n);
	printf("sum = %d\n", sum);
	exit(0);
}
